package dev.shadowsoffire.apotheosis.ench.anvil;

import net.minecraft.nbt.ListTag;
import net.minecraft.nbt.Tag;
import java.util.Map;
import net.minecraft.world.item.enchantment.EnchantmentHelper;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Items;
import net.minecraft.nbt.CompoundTag;
import it.unimi.dsi.fastutil.objects.Object2IntOpenHashMap;
import dev.shadowsoffire.apotheosis.Apoth;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.core.BlockPos;
import net.minecraft.world.item.enchantment.Enchantment;
import it.unimi.dsi.fastutil.objects.Object2IntMap;
import net.minecraft.world.level.block.entity.BlockEntity;

public class AnvilTile extends BlockEntity
{
    protected final Object2IntMap<Enchantment> enchantments;
    
    public AnvilTile(final BlockPos pos, final BlockState state) {
        super((BlockEntityType)Apoth.Tiles.ANVIL.get(), pos, state);
        this.enchantments = (Object2IntMap<Enchantment>)new Object2IntOpenHashMap();
    }
    
    public void m_183515_(final CompoundTag tag) {
        final ItemStack stack = new ItemStack((ItemLike)Items.f_42146_);
        EnchantmentHelper.m_44865_((Map)this.enchantments, stack);
        tag.m_128365_("enchantments", (Tag)stack.m_41785_());
    }
    
    public void m_142466_(final CompoundTag tag) {
        super.m_142466_(tag);
        final ListTag enchants = tag.m_128437_("enchantments", 10);
        final Map<Enchantment, Integer> map = EnchantmentHelper.m_44882_(enchants);
        this.enchantments.clear();
        this.enchantments.putAll((Map)map);
    }
    
    public Object2IntMap<Enchantment> getEnchantments() {
        return this.enchantments;
    }
}
